#! /usr/bin/awk -f
# generate topology file for orac from libgenpar OPLS file itp.
# The itp file must contain the atoms,bonds, and improper specificatiobn ONLY.
# the name of teh residue must be specified   
BEGIN{
    first_bond=0
    first_im=0
    first_res=0
    printf "%1s%30s ", "#",  "Done with itp2tpg.awk" ;       system("date")  
}
{   x=substr($0,1,1); y=substr($1,1,1);
    if(y!~"[;#!]") {
	if($1=="[" &&  $2!="atoms" &&  $2!="bonds" && $2!="improper")  {  
	    atom=0; bond=0; impr=0; b=0 ; im=0
	    if(first_res==0) {
		print "######" 
		print "RESIDUE",tolower($2)
		first_res=1
	    }
	    else {
		printf "\n"
		print "end"
		print "termatom n c" 
		print "backbone n ca c"
		print "RESIDUE_END"
		print "######" 
		print "RESIDUE",tolower($2)
		first_bond=0
		first_im=0
	    }
	}  
	if(first_res==1 && NF >1) { 
	    if(substr($2,1,4)=="atom") {print "atoms"; atom=1};  
	    if(substr($2,1,4)=="bond") {print "end"; print "bonds"; bond=1;atom=0};  
	    if(substr($2,1,4)=="impr") {printf "\n"; print "end"; print "imphd"; impr=1; bond=0; atom=0};  
	    if(atom==1 && $1!= "[") {
		im=0
		printf "%7s%10s%8.4f\n", tolower($5),tolower($2),$7
		name[$1]=tolower($5)
	    } 
	    if(atom==0 && bond == 1 && $1!= "[" && NF >= 2 ) {
		if($1!="n+" || $2!="n+" ) {
		    im=0
		    b++
		    if(int(int((b-1)/4))==(b-1)/4 && b>=4) {printf "\n"}
		    printf "%7s%7s  ", name[$1],name[$2] 
		}
	    }
	    if(atom==0 && bond==0 && impr=1 && NF >= 4 && $1!= "[") {
		im++
		if(int(int((im-1)/2))==(im-1)/2 && im >=2) {printf "\n"}
		printf "%7s%7s%7s%7s  ", name[$1],name[$2],name[$3],name[$4]
	    }
	}
    } 
}

END { 
    printf "\n" 
    print "end"
    print "termatom n c" 
    print "backbone n ca c"
    print "RESIDUE_END"
}
